﻿using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace UniversalSample
{
    public class BitlyHelper
    {
        /// <summary>
        /// Access Token
        /// </summary>
        internal string _accessToken ;

        private static BitlyHelper _instance;

        /// <summary>
        /// BitlyHelper Instance
        /// </summary>
        public static BitlyHelper Instance
        {
            get { return _instance = _instance ?? new BitlyHelper(); }
        }

        /// <summary>
        /// Bitly 인증
        /// </summary>
        /// <param name="id"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        public async Task<bool> BitlyAuthAsync(string id, string password)
        {
            var con = string.Format("grant_type=password&username={0}&password={1}", id, password);
            var content = new StringContent(con, Encoding.UTF8, "application/x-www-form-urlencoded");

            var hc = new HttpClient();
            //여기서 사용한 ZDdi... 부분은 자신의 계정에 있는 Client ID, Client Secret를 이용해서 만든 후 사용한다. - 포스트 후에 코드 변경 할 예정임
            hc.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", "ZDdiZTg1ZTYyZGZhNjE2YjllY2UwNWU5YjJkOTYzODQwNzI0ODEyMTo1OTE2MjIxNjViZDhkMmU3MDI4YmMwYjBjN2VmYTQ2OWVkY2NjZTYy");
            //YjA3YjIyYWFlYTVjMWQ2NDJkZTM3ZThlMmIzZjI0OGQ2Y2UyMmVmODoyYmQyZThjODdhMjEwNDM5YmY4NmFlOGQ3ODkyODQ4YWQxNzRmYmEz
            //ZDdiZTg1ZTYyZGZhNjE2YjllY2UwNWU5YjJkOTYzODQwNzI0ODEyMTo1OTE2MjIxNjViZDhkMmU3MDI4YmMwYjBjN2VmYTQ2OWVkY2NjZTYy
            var result = await hc.PostAsync("https://api-ssl.bitly.com/oauth/access_token", content);
            if (result == null) return false;

            var jobj = JsonConvert.DeserializeObject<JObject>(await result.Content.ReadAsStringAsync());
            if (jobj == null) return false;

            _accessToken = jobj["access_token"].ToString();

            return true;
        }

        /// <summary>
        /// Shorten
        /// </summary>
        /// <param name="longUrl"></param>
        /// <returns></returns>
        public async Task<string> GetShortenUrl(string longUrl)
        {
            var returnValue = string.Empty;

            var hc = new HttpClient();
            var uri = string.Format("https://api-ssl.bitly.com/v3/shorten?access_token={0}&longUrl={1}", _accessToken, longUrl);
            var result = await hc.GetStringAsync(uri);
            if (result == null) return returnValue;

            var jobj = JsonConvert.DeserializeObject<JObject>(result);
            if (jobj == null) return returnValue;

            var data = jobj["data"];
            if (data == null) return returnValue;

            returnValue = data["url"].ToString();

            return returnValue;
        }
    }
}
