﻿using System.Collections.Generic;
using System.Linq;
using Windows.ApplicationModel;
using Windows.UI.Xaml.Navigation;
using UniversalSample.Commons;
using UniversalSample.Design;
using UniversalSample.Models;

namespace UniversalSample.ViewModels
{
    public class ClassDetailPageVM : ViewModelBase
    {
        private IList<ClassM> _classList;
        private ClassM _currentClass;
        private string _selectedValue;

        public string SelectedValue
        {
            get { return _selectedValue; }
            set { SetProperty(ref _selectedValue, value); }
        }

        public object TestList { get; set; }

        public ClassDetailPageVM()
        {
            Title = "Class detail page";

            ClassList = new List<ClassM>();
            ClassList.Add(new ClassM
            {
                Name = "Windows PHone 8.1",     
                Description = "Windows Phone Study"
            });
                
            if (DesignMode.DesignModeEnabled)
            {
                CurrentClass = DesignDatas.GetClassList().First();
            }
            else
            {
                TestList = ClassList;
                ViewModelLocator.MemoryViewer.AddObject(this);
            }
        }

        public IList<ClassM> ClassList
        {
            get { return _classList; }
            set { SetProperty(ref _classList, value); }
        }

        public ClassM CurrentClass
        {
            get { return _currentClass; }
            set
            {
                _currentClass = value;
                OnPropertyChanged();
            }
        }

        protected override void OnNavigating(NavigatingCancelEventArgs e)
        {
        }

        protected override void OnNavigated(NavigationEventArgs e)
        {
            if (e.NavigationMode == NavigationMode.New)
            {
                CurrentClass = e.Parameter as ClassM;
            }
        }

        protected override void OnSizeChanged(object args)
        {
            
        }
    }
}